OSDN Git Service

Fix typos in last change.
[pf3gnuchains/gcc-fork.git] / gcc / fixincludes
index 1cab4c3..51616e4 100755 (executable)
@@ -14,21 +14,45 @@ SRCDIR=${3-${SRCDIR-.}}
 # (This was named INCLUDES, but that conflicts with a name in Makefile.in.)
 INPUT=${2-${INPUT-/usr/include}}
 
-# This prevents /bin/ex from failing if the current terminal type is
-# unrecognizable.
-TERM=unknown
-export TERM
-
 # Directory in which to store the results.
 LIB=${1?"fixincludes: output directory not specified"}
 
+# Define PWDCMD as a command to use to get the working dir
+# in the form that we want.
+PWDCMD=pwd
+case "`pwd`" in
+//*)
+       # On an Apollo, discard everything before `/usr'.
+       PWDCMD="eval pwd | sed -e 's,.*/usr/,/usr/,'"
+       ;;
+esac
+
+# Original directory.
+ORIGDIR=`${PWDCMD}`
+
 # Make sure it exists.
 if [ ! -d $LIB ]; then
   mkdir $LIB || exit 1
 fi
 
-# Make LIB absolute.
-cd $LIB; LIB=`pwd`
+# Make LIB absolute only if needed to avoid problems with the amd.
+case $LIB in
+/*)
+       ;;
+*)
+       cd $LIB; LIB=`${PWDCMD}`
+       ;;
+esac
+
+# Make SRCDIR absolute only if needed to avoid problems with the amd.
+cd $ORIGDIR
+case $SRCDIR in
+/*)
+       ;;
+*)
+       cd $SRCDIR; SRCDIR=`${PWDCMD}`
+       ;;
+esac
 
 # Fail if no arg to specify a directory for the output.
 if [ x$1 = x ]
@@ -36,7 +60,7 @@ then echo fixincludes: no output directory specified
 exit 1
 fi
 
-echo 'Building fixincludes in ' ${LIB}
+echo Building fixed headers in ${LIB}
 
 # Determine whether this system has symbolic links.
 if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
@@ -46,7 +70,7 @@ else
   LINKS=false
 fi
 
-echo 'Making directories:'
+echo Finding directories and links to directories
 cd ${INPUT}
 # Find all directories and all symlinks that point to directories.
 # Put the list in $files.
@@ -62,6 +86,7 @@ do
     newdirs=
     for d in $dirs
     do
+       echo " Searching $INPUT/$d"
        if [ "$d" != . ]
        then
            d=$d/.
@@ -80,7 +105,8 @@ do
          theselinks=`find $d -type l -print`
        for d1 in $theselinks --dummy--
        do
-           # If it is a directory, add it to $newdirs
+           # If the link points to a directory,
+           # add that dir to $newdirs
            if [ -d $d1 ]
            then
                newdirs="$newdirs $d1"
@@ -93,7 +119,7 @@ do
 done
 
 dirs=
-echo all directories:
+echo "All directories (including links to directories):"
 echo $files
 
 for file in $files; do
@@ -102,6 +128,7 @@ for file in $files; do
   then mkdir $LIB/$file
   fi
 done
+mkdir $LIB/root
 
 # treetops gets an alternating list
 # of old directories to copy
@@ -109,11 +136,11 @@ done
 treetops="${INPUT} ${LIB}"
 
 if $LINKS; then
-  echo 'Making internal symbolic directory links'
+  echo 'Making symbolic directory links'
   for file in $files; do
     dest=`ls -ld $file | sed -n 's/.*-> //p'`
     if [ "$dest" ]; then    
-      cwd=`pwd`
+      cwd=`${PWDCMD}`
       # In case $dest is relative, get to $file's dir first.
       cd ${INPUT}
       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
@@ -123,22 +150,66 @@ if $LINKS; then
       if [ $? = 0 ]; then
        cd $dest
        # X gets the dir that the link actually leads to.
-       x=`pwd`
+       x=`${PWDCMD}`
+       # If a link points to ., make a similar link to .
+       if [ $x = $INPUT ]; then
+         echo $file '->' . ': Making link'
+         rm -fr ${LIB}/$file > /dev/null 2>&1
+         ln -s . ${LIB}/$file > /dev/null 2>&1
        # If link leads back into ${INPUT},
        # make a similar link here.
-       if expr $x : "${INPUT}/.*" > /dev/null; then
+       elif expr $x : "${INPUT}/.*" > /dev/null; then
          # Y gets the actual target dir name, relative to ${INPUT}.
          y=`echo $x | sed -n "s&${INPUT}/&&p"`
-         echo $file '->' $y ': Making link'
+         # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
+         dots=`echo "$file" |
+               sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
+         echo $file '->' $dots$y ': Making link'
          rm -fr ${LIB}/$file > /dev/null 2>&1
-         ln -s ${LIB}/$y ${LIB}/$file > /dev/null 2>&1
+         ln -s $dots$y ${LIB}/$file > /dev/null 2>&1
        else
-         # If the link is to outside ${INPUT},
+         # If the link is to a dir $target outside ${INPUT},
+         # repoint the link at ${INPUT}/root$target
+         # and process $target into ${INPUT}/root$target
          # treat this directory as if it actually contained the files.
-# This line used to have $dest instead of $x.
-# $dest seemed to be wrong for links found in subdirectories
-# of ${INPUT}.  Does this change break anything?
-         treetops="$treetops $x ${LIB}/$file"
+         echo $file '->' root$x ': Making link'
+         if [ -d $LIB/root$x ]
+         then true
+         else
+           dirname=root$x/
+           dirmade=.
+           cd $LIB
+           while [ x$dirname != x ]; do
+             component=`echo $dirname | sed -e 's|/.*$||'`
+             mkdir $component >/dev/null 2>&1
+             cd $component
+             dirmade=$dirmade/$component
+             dirname=`echo $dirname | sed -e 's|[^/]*/||'`
+           done
+         fi
+         # Duplicate directory structure created in ${LIB}/$file in new
+         # root area.
+         for file2 in $files; do
+           case $file2 in
+             $file/./*)
+               dupdir=${LIB}/root$x/`echo $file2 | sed -n "s|^${file}/||p"`
+               echo "Duplicating ${file}'s ${dupdir}"
+               if [ -d ${dupdir} ]
+               then true
+               else
+                 mkdir ${dupdir}
+               fi
+               ;;
+             *)
+               ;;
+           esac
+          done
+         # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
+         dots=`echo "$file" |
+               sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
+         rm -fr ${LIB}/$file > /dev/null 2>&1
+         ln -s ${dots}root$x ${LIB}/$file > /dev/null 2>&1
+         treetops="$treetops $x ${LIB}/root$x"
        fi
       fi
       cd $cwd
@@ -146,16 +217,29 @@ if $LINKS; then
   done
 fi
 
-set - $treetops
+set x $treetops
+shift
 while [ $# != 0 ]; do
   # $1 is an old directory to copy, and $2 is the new directory to copy to.
-  echo "Finding header files in $1:"
   cd ${INPUT}
   cd $1
+# The same dir can appear more than once in treetops.
+# There's no need to scan it more than once.
+  if [ -f $2/DONE ]
+  then
+    files=
+  else
+    touch $2/DONE
+    echo Fixing directory $1 into $2
 # Check .h files which are symlinks as well as those which are files.
 # A link to a header file will not be processed by anything but this.
-  files=`find . -name '*.h' \( -type f -o -type l \) -print`
-  echo 'Checking header files:'
+    if $LINKS; then
+      files=`find . -name '*.h' \( -type f -o -type l \) -print`
+    else
+      files=`find . -name '*.h' -type f -print`
+    fi
+    echo Checking header files
+  fi
 # Note that BSD43_* are used on recent MIPS systems.
   for file in $files; do
 # This call to egrep is essential, since checking a file with egrep
@@ -164,47 +248,75 @@ while [ $# != 0 ]; do
 # Thus, matching every #endif is unacceptable.
 # But the argument to egrep must be kept small, or many versions of egrep
 # won't be able to handle it.
-# rms: I removed `|#[el].*if.*[^/      ]' because it made egrep fail.
-    if egrep '[        _]_IO|CTRL|#define.NULL|#[el]*if.*([0-9]|sparc|vax|sun|pyr)' $file > /dev/null; then
-      echo Fixing $file
+#
+# We use the pattern [!-.0-~] instead of [^/   ] to match a noncomment
+# following #else or #endif because some buggy egreps think [^/] matches
+# newline, and they thus think `#else ' matches `#e[ndiflse]*[         ]+[^/   ]'.
+#
+# We use the pattern [^a-zA-Z0-9_][_a-ce-km-z][a-z0-9] to match an identifier
+# following #if or #elif that is not surrounded by __.  The `a-ce-km-z'
+# in this pattern lacks `d' and `l'; this means we don't worry about
+# identifiers starting with `d' or `l'.  This is OK, since none of the
+# identifiers below start with `d' or `l'.  It also greatly improves
+# performance, since many files contain lines of the form `#if ... defined ...'
+# or `#if lint'.
+    if egrep '//|[     _]_IO|CTRL|^#define.NULL|^#e[nl][ds][ief]*[     ]+[!-.0-~]|^#[el]*if.*[^a-zA-Z0-9_][_a-ce-km-z][a-z0-9]' $file >/dev/null; then
       if [ -r $file ]; then
        cp $file $2/$file >/dev/null 2>&1       \
        || echo "Can't copy $file"
        chmod +w $2/$file
-# Following two lines removed.
-#        s%^\([        ]*#[    ]*endif[        ]*\)\([^/       ].*\)$%\1/* \2 */%
-#        s%^\([        ]*#[    ]*else[         ]*\)\([^/       ].*\)$%\1/* \2 */%
-
+       chmod a+r $2/$file
+       # Here is how the sed commands in braces work.
+       # (It doesn't work to put the comments inside the sed commands.)
+               # Surround each word with spaces, to simplify matching below.
+               # ANSIfy each pre-ANSI machine-dependent symbol
+               # by surrounding it with __ __.
+               # Remove the spaces that we inserted around each word.
        sed -e '
                                   :loop
          /\\$/                 N
          /\\$/                 b loop
-         /[    ]_IO[A-Z]*[     ]*(/    s/(\(.\),/('\''\1'\'',/
+         s%^\([        ]*#[    ]*else\)[       ]*/[^*].*%\1%
+         s%^\([        ]*#[    ]*else\)[       ]*[^/   ].*%\1%
+         s%^\([        ]*#[    ]*endif\)[      ]*/[^*].*%\1%
+         s%^\([        ]*#[    ]*endif\)[      ]*[^/   ].*%\1%
+         /\/\/[^*]/                    s|//\(.*\)$|/*\1*/|
+         /[    ]_IO[A-Z]*[     ]*(/    s/\(_IO[A-Z]*[  ]*(\)\(.\),/\1'\''\2'\'',/
          /[    ]BSD43__IO[A-Z]*[       ]*(/    s/(\(.\),/('\''\1'\'',/
-         /#define._IO/                 s/'\''x'\''/x/g
-         /#define.BSD43__IO/           s/'\''x'\''/x/g
-         /[^A-Z]CTRL[  ]*(/            s/\([^'\'']\))/'\''\1'\'')/
-         /#define.CTRL/                s/'\''c'\''/c/g
-         /#define._CTRL/               s/'\''c'\''/c/g
-         /#define.BSD43_CTRL/          s/'\''c'\''/c/g
-         /#[a-z]*if.*[  (]m68k/        s/\([^_]\)m68k/\1__m68k__/g
-         /#[a-z]*if.*[  (]__i386/      s/__i386/__i386__/g
-         /#[a-z]*if.*[  (]i386/        s/\([^_]\)i386/\1__i386__/g
-         /#[a-z]*if.*[  (]sparc/       s/\([^_]\)sparc/\1__sparc__/g
-         /#[a-z]*if.*[  (]mc68000/     s/\([^_]\)mc68000/\1__mc68000__/g
-         /#[a-z]*if.*[  (]vax/         s/\([^_]\)vax/\1__vax__/g
-         /#[a-z]*if.*[  (]sun/         s/\([^_]\)\(sun[a-z0-9]*\)\([^a-z0-9_]\)/\1__\2__\3/g
-         /#[a-z]*if.*[  (]sun/         s/\([^_]\)\(sun[a-z0-9]*\)$/\1__\2__/g
-         /#[a-z]*if.*[  (]ns32000/     s/\([^_]\)ns32000/\1__ns32000__/g
-         /#[a-z]*if.*[  (]pyr/         s/\([^_]\)pyr/\1__pyr__/g
-         /#[a-z]*if.*[  (]is68k/       s/\([^_]\)is68k/\1__is68k__/g
+         /#define._IO/                 s/'\''\([cgx]\)'\''/\1/g
+         /#define.BSD43__IO/           s/'\''\([cgx]\)'\''/\1/g
+         /[^A-Z0-9_]CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
+         /[^A-Z0-9]_CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
+         /#define.CTRL/                s/'\''\([cgx]\)'\''/\1/g
+         /#define._CTRL/               s/'\''\([cgx]\)'\''/\1/g
+         /#define.BSD43_CTRL/          s/'\''\([cgx]\)'\''/\1/g
+         /#[el]*if/{
+               s/[a-zA-Z0-9_][a-zA-Z0-9_]*/ & /g
+
+               s/ bsd4\([0-9]\) / __bsd4\1__ /g
+               s/ _*i386 / __i386__ /g
+               s/ is68k / __is68k__ /g
+               s/ m68k / __m68k__ /g
+               s/ mc680\([0-9]\)0 / __mc680\10__ /g
+               s/ news\([0-9]*\) / __news\1__ /g
+               s/ ns32000 / __ns32000__ /g
+               s/ pyr / __pyr__ /g
+               s/ sony_news / __sony_news__ /g
+               s/ sparc / __sparc__ /g
+               s/ sun\([a-z0-9]*\) / __sun\1__ /g
+               s/ unix / __unix__ /g
+               s/ vax / __vax__ /g
+
+               s/ \([a-zA-Z0-9_][a-zA-Z0-9_]*\) /\1/g
+         }
          /^#define.NULL[       ]/      i\
                #undef NULL
-       ' $2/$file > $2/$file.sed
-       mv $2/$file.sed $2/$file
+       ' $2/$file > $2/$file.
+       mv $2/$file. $2/$file
        if cmp $file $2/$file >/dev/null 2>&1; then
-          echo Deleting $2/$file\; no fixes were needed.
           rm $2/$file
+       else
+          echo Fixed $file
        fi
       fi
     fi
@@ -214,22 +326,77 @@ done
 
 cd ${INPUT}
 
+# Install the proper definition of size_t in header files that it comes from.
+for file in sys/types.h sys/stdtypes.h;
+do
+  if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+    cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+    chmod +w ${LIB}/$file 2>/dev/null
+    chmod a+r ${LIB}/$file 2>/dev/null
+  fi
+
+  if [ -r ${LIB}/$file ]; then
+    echo Fixing $file comment
+    # Extract the definition of SIZE_TYPE, if any.
+    # (This file must be called something.c).
+    echo "#include \"tm.h\"
+gobblegobble SIZE_TYPE" > ${LIB}/types.c
+    foo=`cd ${LIB}; cc -E -I${ORIGDIR} -I${SRCDIR} -I${SRCDIR}/config types.c | grep gobblegobble | sed -e "s/gobblegobble[    ]*//"`
+    rm -f ${LIB}/types.c
+    # Default to our preferred type.
+    if [ "$foo" = SIZE_TYPE ]; then foo="unsigned long int"; else foo=`echo $foo | sed -e 's/^.*"\(.*\)".*$/\1/'`; fi
+    sed -e "s/typedef[         a-z_]*[         ]size_t/typedef $foo size_t/" ${LIB}/$file > ${LIB}/${file}.sed
+    rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+    if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+      rm ${LIB}/$file
+    fi
+  fi
+done
+
 # Fix one other error in this file: a mismatched quote not inside a C comment.
 file=sundev/vuid_event.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/sundev 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file comment
-  ex ${LIB}/$file <<EOF
-  g/doesn't/s/doesn't/does not/
-  wq
-EOF
+  sed -e "s/doesn't/does not/" ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+
+# Fix these Sun OS files to avoid an invalid identifier in an #ifdef.
+file=sunwindow/win_cursor.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+#  mkdir ${LIB}/sunwindow 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+fi
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file
+  sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+file=sunwindow/win_lock.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+#  mkdir ${LIB}/sunwindow 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+fi
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file
+  sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -239,69 +406,69 @@ file=sys/stdtypes.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file
-  ex ${LIB}/$file <<EOF
-  /size_t.*;/
-  i
-#ifndef _GCC_SIZE_T
-#define _GCC_SIZE_T
-.
-  /size_t/+1
-  i
-#endif
-.
-  /ptrdiff_t.*;/
-  i
-#ifndef _GCC_PTRDIFF_T
-#define _GCC_PTRDIFF_T
-.
-  /ptrdiff_t/+1
-  i
-#endif
-.
-  /wchar_t.*;/
-  i
-#ifndef _GCC_WCHAR_T
-#define _GCC_WCHAR_T
-.
-  /wchar_t/+1
-  i
-#endif
-.
-  wq
-EOF
+sed -e '/[      ]size_t.*;/i\
+#ifndef _GCC_SIZE_T\
+#define _GCC_SIZE_T' \
+    -e '/[      ]size_t.*;/a\
+#endif' \
+    -e '/[      ]ptrdiff_t.*;/i\
+#ifndef _GCC_PTRDIFF_T\
+#define _GCC_PTRDIFF_T' \
+    -e '/[      ]ptrdiff_t.*;/a\
+#endif' \
+    -e '/[      ]wchar_t.*;/i\
+#ifndef _GCC_WCHAR_T\
+#define _GCC_WCHAR_T' \
+    -e '/[      ]wchar_t.*;/a\
+#endif' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
 
-# Fix this file to avoid interfering with stddef.h.
+# Fix this file to avoid interfering with stddef.h, but don't mistakenly
+# match e.g. ssize_t present in AIX for the ps/2.
 file=sys/types.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file
-  ex ${LIB}/$file <<EOF
-  /typedef.*size_t.*;/
-  i
-#ifndef _GCC_SIZE_T
-#define _GCC_SIZE_T
-.
-  /size_t/+1
-  i
-#endif
-.
-  wq
-EOF
+sed -e '/[     ]size_t.*;/i\
+#ifndef _GCC_SIZE_T\
+#define _GCC_SIZE_T' \
+    -e '/[     ]size_t.*;/a\
+#endif' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+
+# Fix an error in this file: the #if says _cplusplus, not the double
+# underscore __cplusplus that it should be
+file=tinfo.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  mkdir ${LIB}/rpcsvc 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, __cplusplus macro
+  sed -e 's/[  ]_cplusplus/ __cplusplus/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -313,16 +480,14 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/rpcsvc 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, definition of statsswtch
-  ex ${LIB}/$file <<EOF
-  g/boottime$/s//&;/
-  wq
-EOF
+  sed -e 's/boottime$/boottime;/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -334,16 +499,14 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/netdnet 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, definition of nodeent
-  ex ${LIB}/$file <<EOF
-  g/char.*na_addr *$/s//&;/
-  wq
-EOF
+  sed -e 's/char.*na_addr *$/char *na_addr;/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -353,56 +516,32 @@ file=sys/file.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, bad \#ifdef line
-  ex ${LIB}/$file <<EOF
-  g/^#ifdef KERNEL && !defined/
-  s/#ifdef KERNEL && !defined/#if defined(KERNEL) \&\& !defined/
-  wq
-EOF
+  sed -e 's/#ifdef KERNEL/#if defined(KERNEL)/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
 
-# Remove nested comments created by #endifs in a comment (Ultrix 4.1)
-# Only needed if commenting out junk after #endif.
-#file=signal.h
-#if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
-#  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
-#  chmod +w ${LIB}/$file 2>/dev/null
-#fi
-#
-#if [ -r ${LIB}/$file ]; then
-#  echo Fixing $file, nested comments
-#  sed -e 's/#endif.*/#endif/' ${LIB}/$file > ${LIB}/${file}.sed
-#  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
-#  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-#    echo Deleting ${LIB}/$file\; no fixes were needed.
-#    rm -f ${LIB}/$file
-#  fi
-#fi
-
 # Check for superfluous `static' (in Ultrix 4.2)
 file=machine/cpu.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/machine 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, superfluous static
-  ex ${LIB}/$file <<EOF
-  g/^static struct tlb_pid_state/
-  s/static//
-  wq
-EOF
+  sed -e 's/^static struct tlb_pid_state/struct tlb_pid_state/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   else
 # This file has an alternative name, mips/cpu.h.  Fix that name, too.
@@ -419,20 +558,16 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/X11 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file sprintf declaration
-  ex ${LIB}/$file <<EOF
-  /^extern char \*     sprintf();$/c
-#ifndef __STDC__
-extern char *  sprintf();
-#endif /* !defined __STDC__ */
-.
-  wq
-EOF
+  sed -e 's,^extern char \*    sprintf();$,#ifndef __STDC__\
+extern char *  sprintf();\
+#endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -444,20 +579,16 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/X11/Xmu 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file sprintf declaration
-  ex ${LIB}/$file <<EOF
-  /^extern char \*     sprintf();$/c
-#ifndef __STDC__
-extern char *  sprintf();
-#endif /* !defined __STDC__ */
-.
-  wq
-EOF
+  sed -e 's,^extern char \*    sprintf();$,#ifndef __STDC__\
+extern char *  sprintf();\
+#endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -468,6 +599,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/netinet 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -475,7 +607,6 @@ if [ -r ${LIB}/$file ]; then
   sed -e '/^struct/,/^};/s/}$/};/' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -486,6 +617,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/pixrect 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -499,7 +631,6 @@ if [ -r ${LIB}/$file ]; then
 ' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -510,6 +641,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/rpcsvc 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -517,7 +649,6 @@ if [ -r ${LIB}/$file ]; then
   sed -e '/^struct/,/^};/s/_cnt$/_cnt;/' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -527,6 +658,7 @@ file=stdlib.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -539,7 +671,6 @@ if [ -r ${LIB}/$file ]; then
   -e 's/int    exit/void       exit/g' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -549,6 +680,7 @@ file=malloc.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -558,25 +690,6 @@ if [ -r ${LIB}/$file ]; then
   ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
-    rm -f ${LIB}/$file
-  fi
-fi
-
-
-# Fix bogus comment in <locale.h> on SunOS 4.1.
-file=locale.h
-if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
-  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
-  chmod +w ${LIB}/$file 2>/dev/null
-fi
-
-if [ -r ${LIB}/$file ]; then
-  echo Fixing $file
-  sed -e 's%#endif / \*%#endif /\* %g' ${LIB}/$file > ${LIB}/${file}.sed
-  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
-  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -587,15 +700,15 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/hsfs 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file
   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
-    ${LIB}/$file > ${LIB}/${file}.sed
-  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+    ${LIB}/$file > ${LIB}/${file}.
+  rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -606,6 +719,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/hsfs 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -614,7 +728,6 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -625,6 +738,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/hsfs 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -633,7 +747,6 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -644,15 +757,15 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/machine 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, incorrect \#include
   sed -e 's@"../machine/endian.h"@<machine/endian.h>@' \
-    ${LIB}/$file > ${LIB}/${file}.sed
-  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+    ${LIB}/$file > ${LIB}/${file}.
+  rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -663,6 +776,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/sys 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -672,7 +786,32 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# Turning // comments into /* */ comments trashes this IRIX 4.0.1
+# header file, which embeds // comments inside multi-line /* */
+# comments.  If this looks like the IRIX header file, we refix it by
+# just throwing away the // comments.
+file=fam.h
+if [ -r ${LIB}/$file ]; then
+  if egrep indigo.esd ${LIB}/$file > /dev/null; then
+    echo Fixing $file, overeager sed script
+    rm ${LIB}/$file
+    sed -e 's|//.*$||g' $file > ${LIB}/$file
+    chmod +w ${LIB}/$file 2>/dev/null
+    chmod a+r ${LIB}/$file 2>/dev/null
+  fi
+fi
+
+# Another IRIX 4.0.1 header file contains the string "//"
+file=elf_abi.h
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, overeager sed script
+  sed -e 's|"/\*"\*/|"//"|' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
     rm -f ${LIB}/$file
   fi
 fi
@@ -682,10 +821,11 @@ fi
 # many other systems have similar text but correct versions of the file.
 # To ensure only Sun's is fixed, we grep for a likely unique string.
 file=memory.h
-if egrep '/\*  @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
-  if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+if [ -r $file ] && egrep '/\*  @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
+  if [ ! -r ${LIB}/$file ]; then
     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
     chmod +w ${LIB}/$file 2>/dev/null
+    chmod a+r ${LIB}/$file 2>/dev/null
   fi
   if [ -r ${LIB}/$file ]; then
     echo Replacing $file
@@ -708,7 +848,7 @@ extern char *memset();
 
 extern int memcmp();
 
-#endif __memory_h__
+#endif /* __memory_h__ */
 EOF
   fi
 fi
@@ -718,6 +858,7 @@ file=stdio.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -732,7 +873,58 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# parameters conflict with C++ new on rs/6000 
+file=stdio.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, parameter name conflicts
+  sed -e 's@rename(const char \*old, const char \*new)@rename(const char *_old, const char *_new)@' \
+    ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# Don't use or define the name va_list in stdio.h.
+# This is for ANSI and also to interoperate properly with gvarargs.h.
+file=stdio.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, use of va_list
+  # Arrange for stdio.h to use stdarg.h to define __gnuc_va_list
+  (echo "#define __need___va_list"
+   echo "#include <stdarg.h>") > ${LIB}/${file}.sed
+  # Use __gnuc_va_list in arg types in place of va_list.
+  # On 386BSD use __gnuc_va_list instead of _VA_LIST_. We're hoping the
+  # trailing parentheses and semicolon save all other systems from this.
+  # Define __va_list__ (something harmless and unused) instead of va_list.
+  # Don't claim to have defined va_list.
+  sed -e 's@ va_list @ __gnuc_va_list @' \
+      -e 's@ va_list)@ __gnuc_va_list)@' \
+      -e 's@ _VA_LIST_));@ __gnuc_va_list));@' \
+      -e 's@ va_list@ __va_list__@' \
+      -e 's@\*va_list@*__va_list__@' \
+      -e 's@_NEED___VA_LIST@_NEED___Va_LIST@' \
+      -e 's@VA_LIST@DUMMY_VA_LIST@' \
+      -e 's@_NEED___Va_LIST@_NEED___VA_LIST@' \
+    ${LIB}/$file >> ${LIB}/${file}.sed
+  
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
     rm -f ${LIB}/$file
   fi
 fi
@@ -746,18 +938,73 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
 fi
 
 # parameter to atof not const on DECstation Ultrix V4.0.
+# also get rid of bogus inline definitions in HP-UX 8.0
 file=math.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, non-const arg
   sed -e 's@atof( char \*__nptr );@atof( const char *__nptr );@' \
+      -e 's@inline int abs(int d) { return (d>0)?d:-d; }@@' \
+      -e 's@inline double abs(double d) { return fabs(d); }@@' \
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# In limits.h, put #ifndefs around things that are supposed to be defined
+# in float.h to avoid redefinition errors if float.h is included first.
+# On HP/UX this patch does not work, because on HP/UX limits.h uses
+# multi line comments and the inserted #endif winds up inside the
+# comment.  Fortunately, HP/UX already uses #ifndefs in limits.h; if
+# we find a #ifndef FLT_MIN we assume that all the required #ifndefs
+# are there, and we do not add them ourselves.
+file=limits.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  if egrep 'ifndef[    ]+FLT_MIN' ${LIB}/$file >/dev/null; then
+    true
+  else
+    echo Fixing $file
+    sed -e '/[         ]FLT_MIN[       ]/i\
+#ifndef FLT_MIN'\
+        -e '/[         ]FLT_MIN[       ]/a\
+#endif'\
+        -e '/[         ]FLT_MAX[       ]/i\
+#ifndef FLT_MAX'\
+        -e '/[         ]FLT_MAX[       ]/a\
+#endif'\
+        -e '/[         ]FLT_DIG[       ]/i\
+#ifndef FLT_DIG'\
+        -e '/[         ]FLT_DIG[       ]/a\
+#endif'\
+        -e '/[         ]DBL_MIN[       ]/i\
+#ifndef DBL_MIN'\
+        -e '/[         ]DBL_MIN[       ]/a\
+#endif'\
+        -e '/[         ]DBL_MAX[       ]/i\
+#ifndef DBL_MAX'\
+        -e '/[         ]DBL_MAX[       ]/a\
+#endif'\
+        -e '/[         ]DBL_DIG[       ]/i\
+#ifndef DBL_DIG'\
+        -e '/[         ]DBL_DIG[       ]/a\
+#endif'\
+      ${LIB}/$file > ${LIB}/${file}.sed
+    rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  fi
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
     echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
@@ -775,6 +1022,41 @@ then
   ln -s ${INPUT}/multimedia/audio_hdr.h ${LIB}/multimedia 2>/dev/null
 fi
 
+# Determine if we're on Interactive Unix 2.2 or later, in which case we
+# need to fix some additional files.  This is the same test for ISC that
+# Autoconf uses.
+if test -d /etc/conf/kconfig.d \
+    && grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1; then
+  echo "Fixing ISC __STDC__ goof in several files..."
+  for name in stdio.h math.h ctype.h sys/limits.h sys/fcntl.h sys/dirent.h; do
+    echo $name
+    if test -r ${LIB}/$name; then
+      file=${LIB}/$name
+    else
+      file=${INPUT}/$name
+    fi
+    # On Interactive 2.2, certain traditional Unix definitions
+    # (notably getc and putc in stdio.h) are omitted if __STDC__ is
+    # defined, not just if _POSIX_SOURCE is defined.  This makes it
+    # impossible to compile any nontrivial program except with -posix.
+    sed \
+'s/!defined(__STDC__) && !defined(_POSIX_SOURCE)/!defined(_POSIX_SOURCE)/' \
+           < $file > ${LIB}/$name.
+    mv ${LIB}/$name. ${LIB}/$name
+  done
+  
+  echo "Fixing ISC fmod declaration"
+  # This one's already been fixed for other things.
+  file=${LIB}/math.h
+  sed 's/fmod(double)/fmod(double, double)/' <$file >$file.
+  mv $file. $file
+  
+  echo "Fixing nested comments in ISC <sys/limits.h>"
+  file=sys/limits.h
+  sed '/CHILD_MAX/s,/\* Max, Max,' < ${INPUT}/$file >${LIB}/$file.
+  sed '/OPEN_MAX/s,/\* Max, Max,' < ${LIB}/$file. >${LIB}/$file
+fi
+
 echo 'Removing unneeded directories:'
 cd $LIB
 files=`find . -type d -print | sort -r`
@@ -797,4 +1079,8 @@ if $LINKS; then
   done
 fi
 
+echo 'Cleaning up DONE files.'
+cd $LIB
+find . -name DONE -exec rm -f {} ';'
+
 exit 0